#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>

#include <sys/poll.h>

#include <fcntl.h>

#include <unistd.h>

#include <errno.h>

#include "dns2.h"
#include "utils.h"
#include "packet.h"
#include "constants.h"
#include "glist.h"
#include "rr.h"

#include "dns2-private.h"

DNS2 *dns2_resolver_new (int recursion) {
	DNS2 *resolver;
	
	resolver = dns2_new ();
	
	if (resolver == NULL) {
		return NULL;
	}
	
	resolver->want_recursion = recursion;
	resolver->type = DNS_RESOLVER;
	
	return resolver;
}

void dns2_resolver_set_question (DNS2 *resolver, const char *name, int type, int klass) {
	if (resolver->packet != NULL) {
		dns_packet_free_full (resolver->packet);
		resolver->packet = NULL;
	}
	
	resolver->packet = dns_packet_create_request (name, type, klass);
	
	if (resolver->packet == NULL) {
		/* FIXME: ¿Qué hacemos? */
		return;
	}
	
	resolver->packet->header.opcode = OPCODE_QUERY;
	resolver->packet->header.rd = resolver->want_recursion;
}

